# Search Attribute

## Description:

### Allowed Parent Components:

1. Smart Search

### Allowed Child Components:

1. Trigger Before Render
2. Trigger On Change

### Properties

### ➤ Enable Condition

Specify an expression that should be evaluated to a boolean \[e.g. #{dsAlias.attr1} == 'X' && #{dsAlias.attr2} > 1]. If no expression is specified, it will be considered as true.

Allowed Values: An expression which should return boolean after evaluation

### ➤ Attribute Code

Enter the attribute code of the datasource that can be selected by the user from the filter list in the smart search.

Allowed Values: Free text field

### ➤ Label

Enter the text for the attribute code to be displayed in the filter list.

Allowed Values: Free text field

### ➤ Data Type

Choose the data type of the attribute. On the basis of the selected data type, the HTML input field will be displayed in the search.

Allowed Values:

1. Text
2. Number
3. Date
4. Select

### ➤ Default Text Operator

Choose an option to apply the default operator in the search when this attribute is selected.

Allowed Values:

1. {"value":"eq","label":"is"}
2. {"value":"neq","label":"is not"}
3. {"value":"NULL","label":"is empty"}
4. {"value":"NOTNULL","label":"is not empty"}
5. {"value":"nct","label":"not contains"}
6. {"value":"LIKE","label":"contains"}
7. {"value":"SW","label":"starts with"}
8. {"value":"EW","label":"ends with"}
9. {"value":"hasAll","label":"has all of the words"}
10. {"value":"hasAny","label":"has any of the words"}
11. {"value":"notAny","label":"does not have any of the words"}
12. {"value":"in","label":"in"}
13. {"value":"notIn","label":"not in"}
14. {"value":"SOUNDEX","label":"sounds like"}

### ➤ Default Number Operator

Choose an option to apply the default operator in the search when this attribute is selected.

Allowed Values:

1. {"value":"eq","label":"is"}
2. {"value":"ne","label":"is not"}
3. {"value":"NULL","label":"is empty"}
4. {"value":"NOTNULL","label":"is not empty"}
5. {"value":"gt","label":"greater than"}
6. {"value":"gte","label":"greater than or equals"}
7. {"value":"lt","label":"less than"}
8. {"value":"lte","label":"less than or equals"}
9. {"value":"BETWEEN","label":"between"}
10. {"value":"in","label":"in"}
11. {"value":"notIn","label":"not in"}

### ➤ Default Date Operator

Choose an option to apply the default operator in the search when this attribute is selected

Allowed Values:

1. {"value":"on","label":"is on"}
2. {"value":"neq","label":"is not on"}
3. {"value":"NULL","label":"is empty"}
4. {"value":"NOTNULL","label":"is not empty"}
5. {"value":"after","label":"is after"}
6. {"value":"gte","label":"is on or after"}
7. {"value":"before","label":"is before"}
8. {"value":"lte","label":"is on or before"}
9. {"value":"BETWEEN","label":"between"}
10. {"value":"TODAY","label":"is today"}
11. {"value":"YESTERDAY","label":"is yesterday"}
12. {"value":"LAST7DAYS","label":"since last 7 Days"}
13. {"value":"LAST14DAYS","label":"since last 14 Days"}
14. {"value":"LAST28DAYS","label":"since last 28 Days"}
15. {"value":"THISWEEK","label":"is this Week"}
16. {"value":"THISMONTH","label":"is this Month"}
17. {"value":"THISQUATER","label":"is this Quater"}
18. {"value":"THISYEAR","label":"is this Year"}

### ➤ Default Select Operator

Choose an option to apply the default operator in the search when this attribute is selected

Allowed Values:

1. {"value":"eq","label":"is"}
2. {"value":"neq","label":"is not"}
3. {"value":"in","label":"any of"}
4. {"value":"NULL","label":"is empty"}
5. {"value":"NOTNULL","label":"is not empty"}

### ➤ Simple Values

Provide comma seperated values e.g. Blue, Black, Green or value:label pairs e.g. BLUE:Blue, BLACK:Black, G:Green

Allowed Values: An expression which should return string after evaluation

### ➤ Format

Allowed Values: Free text field

### ➤ Use Server Timezone

Check this prop if this date should not be converted to browser's timezone. Also make sure the attribute type is set to 'String Date & Time 2' on the server side DataSource definition.

Allowed Values: Yes/No

### ➤ Time Select

Select this to show time along with the date.

Allowed Values:

1. None
2. Inline
3. Popup

### ➤ Time Format

Select a time format. e.g. HH:mm, hh:mm a, HH:mm:ss

Allowed Values: Free text field

### ➤ Time Intervals

Provide time intervals. e.g. 15 or 30, between 0 and 24 \* 60.

Allowed Values: Any number value

### ➤ Min Time

Provide the min time below which the time cannot be selected or entered.

Allowed Values: Free text field

### ➤ Max Time

Provide the max time above which the time cannot be selected or entered.

Allowed Values: Free text field

### ➤ DataSource

Select a datasource from the list.

Allowed Values: Select a datasource from the list.

### ➤ Data Source Alias

Allowed Values: Free text field

### ➤ Default Where Clause

Allowed Values: Free text field

### ➤ Max Rows

Allowed Values: Any number value

### ➤ Order By Clause

e.g. #firstAttr#, #secondAttr# DESC

Allowed Values: Free text field

### ➤ Value Attribute

Choose an attribute that needs to be stored in the database.

Allowed Values: Choose an attribute that needs to be stored in the database.

### ➤ Display Attribute

Choose an attribute that needs to be visible to the user.

Allowed Values: Choose an attribute that needs to be visible to the user.

### ➤ Remote Filter

Allowed Values: Yes/No

### ➤ Cache Results

With remote filter checked, check this if you want the system to cache data fetched for each filter to avoid re-query if the user types the same filter again

Allowed Values: Yes/No

### ➤ Do Not Prefetch

Check this to programmatically control this Select Query

Allowed Values: Yes/No


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.cloudio.io/ui-components/widgets/iosearchattribute.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
